﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace LayoutSDK_Sample
{
    public partial class Form1 : Form
    {
        //Work folder.
        string folder = "";

        public Form1()
        {
            InitializeComponent();
        }

        //Run.
        private void button1_Click(object sender, EventArgs e)
        {
            string sdk_ver = "";
            string eng_ver = "";
            LayoutDesigner2_SDK.LibApi api = new LayoutDesigner2_SDK.LibApi();
            int size = 0;
            string[] obj_list = new string[100];
            int obj_count = 0;
            string one = "";
            Rectangle rect;
            Point st;
            Point ed;
            bool ret = false;
            int api_angle = comboBox2.SelectedIndex;

            //No folder specified?
            if (textBox1.Text == "")
            {
                MessageBox.Show("Please specify the working folder.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            //SDK initialization.
            ret = api.InitSdk();
            //Initialization failure?
            if (ret == false)
            {
                MessageBox.Show("Failed to initialize SDK.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            //Get version.
            ret = api.GetApiVersion(ref sdk_ver, ref eng_ver);
            //Acquisition failure?
            if (ret == false)
            {
                MessageBox.Show("Failed to get the version.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            //Set the SDK version in the text box.
            textBox8.Text = sdk_ver.ToString();
            //Set the engine version in the text box.
            textBox9.Text = eng_ver.ToString();

            //Clear the list box.
            listBox1.Items.Clear();

            //Is there a base SOP file specified?
            if (textBox7.Text != "")
            {
                //File load.
                ret = api.LoadSopFile(textBox7.Text, ref size);
                //Load failed?
                if (ret == false)
                {
                    MessageBox.Show("Failed to read the base SOP file.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
            }
            //If the base SOP file is not specified, it will be newly created.
            else
            {
                //Create New.
                ret = api.NewSopFile(LayoutDesigner2_SDK.LibApi.PRINTER_SM4_31, 72 * 8, 75 * 8, 0, 0);
                //New creation failed?
                if (ret == false)
                {
                    MessageBox.Show("Failed to create a new SOP file.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
            }

            //Data creation.
            one = "";
            rect = new Rectangle(5, 10, 160, 60);
            ret = api.SetRectData(ref one, rect, LayoutDesigner2_SDK.LibApi.LINE_WIDTH_2DOT, LayoutDesigner2_SDK.LibApi.LINE_TYPE_SOLID, api_angle);

            one = "";
            rect = new Rectangle(6, 11, 158, 30);
            ret = api.SetFillData(ref one, rect, LayoutDesigner2_SDK.LibApi.FILL_COLOR_INVERSION, api_angle);

            one = "";
            rect = new Rectangle(8, 12, 147, 26);
            ret = api.SetTextData(ref one, rect, "e発送サービス", LayoutDesigner2_SDK.LibApi.TEXT_SOURCE_TEXT, "MS UI Gothic", 18, LayoutDesigner2_SDK.LibApi.TEXT_BOLD_ENABLE, 
                                LayoutDesigner2_SDK.LibApi.TEXT_ITALIC_DISABLE, LayoutDesigner2_SDK.LibApi.TEXT_UNDERLINE_DISABLE, LayoutDesigner2_SDK.LibApi.TEXT_STRIKEOUT_DISABLE,
                                LayoutDesigner2_SDK.LibApi.CHARACTER_SET_JAPAN, LayoutDesigner2_SDK.LibApi.TEXT_ALIGN_LEFT, LayoutDesigner2_SDK.LibApi.TEXT_AUTO_SIZE_ENABLE, api_angle);

            one = "";
            rect = new Rectangle(30, 42, 108, 26);
            ret = api.SetTextData(ref one, rect, "料金後納", LayoutDesigner2_SDK.LibApi.TEXT_SOURCE_TEXT, "MS UI Gothic", 18, LayoutDesigner2_SDK.LibApi.TEXT_BOLD_ENABLE, LayoutDesigner2_SDK.LibApi.TEXT_ITALIC_DISABLE,
                               LayoutDesigner2_SDK.LibApi.TEXT_UNDERLINE_DISABLE, LayoutDesigner2_SDK.LibApi.TEXT_STRIKEOUT_DISABLE, LayoutDesigner2_SDK.LibApi.CHARACTER_SET_JAPAN, LayoutDesigner2_SDK.LibApi.TEXT_ALIGN_LEFT,
                               LayoutDesigner2_SDK.LibApi.TEXT_AUTO_SIZE_ENABLE, api_angle);

            one = "";
            rect = new Rectangle(6, 85, 130, 60);
            ret = api.SetFillData(ref one, rect, LayoutDesigner2_SDK.LibApi.FILL_COLOR_INVERSION, api_angle);

            one = "";
            rect = new Rectangle(7, 90, 124, 50);
            ret = api.SetTextData(ref one, rect, "プライバシー\n　　配送", LayoutDesigner2_SDK.LibApi.TEXT_SOURCE_TEXT, "MS UI Gothic", 18, LayoutDesigner2_SDK.LibApi.TEXT_BOLD_ENABLE, LayoutDesigner2_SDK.LibApi.TEXT_ITALIC_DISABLE,
                               LayoutDesigner2_SDK.LibApi.TEXT_UNDERLINE_DISABLE, LayoutDesigner2_SDK.LibApi.TEXT_STRIKEOUT_DISABLE, LayoutDesigner2_SDK.LibApi.CHARACTER_SET_JAPAN, LayoutDesigner2_SDK.LibApi.TEXT_ALIGN_LEFT,
                               LayoutDesigner2_SDK.LibApi.TEXT_AUTO_SIZE_ENABLE, api_angle);

            one = "";
            rect = new Rectangle(5, 165, 130, 40);
            ret = api.SetFillData(ref one, rect, LayoutDesigner2_SDK.LibApi.FILL_COLOR_INVERSION, api_angle);

            one = "";
            rect = new Rectangle(10, 170, 117, 26);
            ret = api.SetTextData(ref one, rect, "ゆうパケット", LayoutDesigner2_SDK.LibApi.TEXT_SOURCE_TEXT, "MS UI Gothic", 18, LayoutDesigner2_SDK.LibApi.TEXT_BOLD_ENABLE, LayoutDesigner2_SDK.LibApi.TEXT_ITALIC_DISABLE,
                               LayoutDesigner2_SDK.LibApi.TEXT_UNDERLINE_DISABLE, LayoutDesigner2_SDK.LibApi.TEXT_STRIKEOUT_DISABLE, LayoutDesigner2_SDK.LibApi.CHARACTER_SET_JAPAN, LayoutDesigner2_SDK.LibApi.TEXT_ALIGN_LEFT,
                               LayoutDesigner2_SDK.LibApi.TEXT_AUTO_SIZE_ENABLE, api_angle);

            one = "";
            rect = new Rectangle(180, 35, 108, 26);
            ret = api.SetTextData(ref one, rect, "〇〇配送", LayoutDesigner2_SDK.LibApi.TEXT_SOURCE_TEXT, "MS UI Gothic", 18, LayoutDesigner2_SDK.LibApi.TEXT_BOLD_ENABLE, LayoutDesigner2_SDK.LibApi.TEXT_ITALIC_DISABLE,
                               LayoutDesigner2_SDK.LibApi.TEXT_UNDERLINE_DISABLE, LayoutDesigner2_SDK.LibApi.TEXT_STRIKEOUT_DISABLE, LayoutDesigner2_SDK.LibApi.CHARACTER_SET_JAPAN, LayoutDesigner2_SDK.LibApi.TEXT_ALIGN_LEFT,
                               LayoutDesigner2_SDK.LibApi.TEXT_AUTO_SIZE_ENABLE, api_angle);

            one = "";
            rect = new Rectangle(329, 12, 83, 26);
            ret = api.SetTextData(ref one, rect, "貼付用", LayoutDesigner2_SDK.LibApi.TEXT_SOURCE_TEXT, "MS UI Gothic", 18, LayoutDesigner2_SDK.LibApi.TEXT_BOLD_ENABLE, LayoutDesigner2_SDK.LibApi.TEXT_ITALIC_DISABLE,
                               LayoutDesigner2_SDK.LibApi.TEXT_UNDERLINE_DISABLE, LayoutDesigner2_SDK.LibApi.TEXT_STRIKEOUT_DISABLE, LayoutDesigner2_SDK.LibApi.CHARACTER_SET_JAPAN, LayoutDesigner2_SDK.LibApi.TEXT_ALIGN_LEFT,
                               LayoutDesigner2_SDK.LibApi.TEXT_AUTO_SIZE_ENABLE, api_angle);

            one = "";
            rect = new Rectangle(321, 9, 100, 30);
            ret = api.SetRectData(ref one, rect, LayoutDesigner2_SDK.LibApi.LINE_WIDTH_2DOT, LayoutDesigner2_SDK.LibApi.LINE_TYPE_SOLID, api_angle);

            one = "";
            rect = new Rectangle(176, 65, 222, 53);
            ret = api.SetTextData(ref one, rect, "12-34-56", LayoutDesigner2_SDK.LibApi.TEXT_SOURCE_TEXT, "MS UI Gothic", 36, LayoutDesigner2_SDK.LibApi.TEXT_BOLD_ENABLE, LayoutDesigner2_SDK.LibApi.TEXT_ITALIC_DISABLE,
                               LayoutDesigner2_SDK.LibApi.TEXT_UNDERLINE_DISABLE, LayoutDesigner2_SDK.LibApi.TEXT_STRIKEOUT_DISABLE, LayoutDesigner2_SDK.LibApi.CHARACTER_SET_JAPAN, LayoutDesigner2_SDK.LibApi.TEXT_ALIGN_LEFT,
                               LayoutDesigner2_SDK.LibApi.TEXT_AUTO_SIZE_ENABLE, api_angle);

            one = "";
            rect = new Rectangle(6, 215, 420, 355);
            ret = api.SetRectData(ref one, rect, LayoutDesigner2_SDK.LibApi.LINE_WIDTH_2DOT, LayoutDesigner2_SDK.LibApi.LINE_TYPE_SOLID, api_angle);

            one = "";
            rect = new Rectangle(18, 221, 366, 66);
            ret = api.SetTextData(ref one, rect, "(お届け先)　〒171-00**\n東京都 * **\n＜＜プライバシー配送(局窓口受取)＞＞", LayoutDesigner2_SDK.LibApi.TEXT_SOURCE_TEXT, "MS UI Gothic", 16, LayoutDesigner2_SDK.LibApi.TEXT_BOLD_ENABLE, LayoutDesigner2_SDK.LibApi.TEXT_ITALIC_DISABLE,
                               LayoutDesigner2_SDK.LibApi.TEXT_UNDERLINE_DISABLE, LayoutDesigner2_SDK.LibApi.TEXT_STRIKEOUT_DISABLE, LayoutDesigner2_SDK.LibApi.CHARACTER_SET_JAPAN, LayoutDesigner2_SDK.LibApi.TEXT_ALIGN_LEFT,
                               LayoutDesigner2_SDK.LibApi.TEXT_AUTO_SIZE_ENABLE, api_angle);

            one = "";
            st = new Point(6, 290);
            ed = new Point(426, 290);
            ret = api.SetLineData(ref one, st, ed, LayoutDesigner2_SDK.LibApi.LINE_WIDTH_2DOT, LayoutDesigner2_SDK.LibApi.LINE_TYPE_SOLID, api_angle);

            one = "";
            st = new Point(6, 440);
            ed = new Point(426, 440);
            ret = api.SetLineData(ref one, st, ed, LayoutDesigner2_SDK.LibApi.LINE_WIDTH_2DOT, LayoutDesigner2_SDK.LibApi.LINE_TYPE_SOLID, api_angle);

            one = "";
            st = new Point(6, 520);
            ed = new Point(426, 520);
            ret = api.SetLineData(ref one, st, ed, LayoutDesigner2_SDK.LibApi.LINE_WIDTH_2DOT, LayoutDesigner2_SDK.LibApi.LINE_TYPE_SOLID, api_angle);

            one = "";
            rect = new Rectangle(17, 301, 256, 26);
            ret = api.SetTextData(ref one, rect, "お問い合わせ　追跡番号", LayoutDesigner2_SDK.LibApi.TEXT_SOURCE_TEXT, "MS UI Gothic", 18, LayoutDesigner2_SDK.LibApi.TEXT_BOLD_ENABLE, LayoutDesigner2_SDK.LibApi.TEXT_ITALIC_DISABLE,
                               LayoutDesigner2_SDK.LibApi.TEXT_UNDERLINE_DISABLE, LayoutDesigner2_SDK.LibApi.TEXT_STRIKEOUT_DISABLE, LayoutDesigner2_SDK.LibApi.CHARACTER_SET_JAPAN, LayoutDesigner2_SDK.LibApi.TEXT_ALIGN_LEFT,
                               LayoutDesigner2_SDK.LibApi.TEXT_AUTO_SIZE_ENABLE, api_angle);

            one = "";
            rect = new Rectangle(17, 336, 188, 26);
            ret = api.SetTextData(ref one, rect, "7253-0000-0390", LayoutDesigner2_SDK.LibApi.TEXT_SOURCE_TEXT, "MS UI Gothic", 18, LayoutDesigner2_SDK.LibApi.TEXT_BOLD_ENABLE, LayoutDesigner2_SDK.LibApi.TEXT_ITALIC_DISABLE,
                               LayoutDesigner2_SDK.LibApi.TEXT_UNDERLINE_DISABLE, LayoutDesigner2_SDK.LibApi.TEXT_STRIKEOUT_DISABLE, LayoutDesigner2_SDK.LibApi.CHARACTER_SET_JAPAN, LayoutDesigner2_SDK.LibApi.TEXT_ALIGN_LEFT,
                               LayoutDesigner2_SDK.LibApi.TEXT_AUTO_SIZE_ENABLE, api_angle);

            one = "";
            rect = new Rectangle(21, 450, 225, 49);
            ret = api.SetTextData(ref one, rect, "(品名) 商品名１　　SK1-311SF4\n　　　　 商品名２　　P - 80 - 120\n　　　　 商品名３　　CB - SK1 - D1", LayoutDesigner2_SDK.LibApi.TEXT_SOURCE_TEXT, "MS UI Gothic", 12, LayoutDesigner2_SDK.LibApi.TEXT_BOLD_ENABLE, LayoutDesigner2_SDK.LibApi.TEXT_ITALIC_DISABLE,
                               LayoutDesigner2_SDK.LibApi.TEXT_UNDERLINE_DISABLE, LayoutDesigner2_SDK.LibApi.TEXT_STRIKEOUT_DISABLE, LayoutDesigner2_SDK.LibApi.CHARACTER_SET_JAPAN, LayoutDesigner2_SDK.LibApi.TEXT_ALIGN_LEFT,
                               LayoutDesigner2_SDK.LibApi.TEXT_AUTO_SIZE_ENABLE, api_angle);

            one = "";
            rect = new Rectangle(21, 530, 353, 33);
            ret = api.SetTextData(ref one, rect, "(記事) 記事１＿５６７８９０１２３４５６７８９０１２３４５\n　　　　 記事２＿５６７８９０１２３４５６７８９０１２３４５", LayoutDesigner2_SDK.LibApi.TEXT_SOURCE_TEXT, "MS UI Gothic", 12, LayoutDesigner2_SDK.LibApi.TEXT_BOLD_ENABLE, LayoutDesigner2_SDK.LibApi.TEXT_ITALIC_DISABLE,
                               LayoutDesigner2_SDK.LibApi.TEXT_UNDERLINE_DISABLE, LayoutDesigner2_SDK.LibApi.TEXT_STRIKEOUT_DISABLE, LayoutDesigner2_SDK.LibApi.CHARACTER_SET_JAPAN, LayoutDesigner2_SDK.LibApi.TEXT_ALIGN_LEFT,
                               LayoutDesigner2_SDK.LibApi.TEXT_AUTO_SIZE_ENABLE, api_angle);

            //Text Object Data Get
            string text_str = "";
            string font_name = "";
            int text_source = 0;
            int font_size = 0;
            int bold = 0;
            int italic = 0;
            int underline = 0;
            int strikeout = 0;
            int char_set = 0;
            int text_align = 0;
            bool auto_size = false;
            int rotate_angle = 0;
            ret = api.GetTextData(one, ref rect, ref text_str, ref text_source, ref font_name, ref font_size, ref bold, ref italic,
                               ref underline, ref strikeout, ref char_set, ref text_align, ref auto_size, ref rotate_angle);
            //Success?
            if(ret == true)
            {
                listBox2.Items.Clear();
                listBox2.Items.Add("Object Name = " + one);
                listBox2.Items.Add("Object Rect X = " + rect.X.ToString() + " Y = " + rect.Y.ToString() + " Width = " + rect.Width.ToString() + " Height = " + rect.Height);
                listBox2.Items.Add("Text String = " + text_str);
                listBox2.Items.Add("Text Source = " + text_source.ToString());
                listBox2.Items.Add("Font Name = " + font_name);
                listBox2.Items.Add("Font Size = " + font_size.ToString());
                listBox2.Items.Add("Font Bold = " + bold.ToString());
                listBox2.Items.Add("Font Italic = " + italic.ToString());
                listBox2.Items.Add("Font Underline = " + underline.ToString());
                listBox2.Items.Add("Font Strikeout = " + strikeout.ToString());
                listBox2.Items.Add("Character Set = " + char_set.ToString());
                listBox2.Items.Add("Text Align  = " + text_align.ToString());
                if (auto_size == true)
                {
                    listBox2.Items.Add("Auto Size  = true");
                }
                else
                {
                    listBox2.Items.Add("Auto Size  = false");
                }
                listBox2.Items.Add("Rotate Angle = " + rotate_angle.ToString());
            }

            one = "";
            rect = new Rectangle(167, 127, 232, 60);
            ret = api.SetBarcode1dData(ref one, rect, @"123456", LayoutDesigner2_SDK.LibApi.BARCODE_SOURCE_TEXT, LayoutDesigner2_SDK.LibApi.BARCODE1D_TYPE_CODE39, LayoutDesigner2_SDK.LibApi.HRI_LOCATE_NONE,
                                            LayoutDesigner2_SDK.LibApi.BAR_WIDTH1, api_angle);

            one = "";
            rect = new Rectangle(296, 318, 99, 99);
            ret = api.SetBarcode2dData(ref one, rect, "725300000390", LayoutDesigner2_SDK.LibApi.BARCODE_SOURCE_TEXT, LayoutDesigner2_SDK.LibApi.BARCODE2D_TYPE_QRCODE, LayoutDesigner2_SDK.LibApi.QRCODE_CELL_SIZE3,
                                            LayoutDesigner2_SDK.LibApi.QRCODE_ECC_Q, 4, LayoutDesigner2_SDK.LibApi.MICRO_PDF417_COLUMNS_SIZE1, api_angle);

            //Macro data.
            string[] start_cmd = { };
            string[] end_cmd = { "FEED,128", "FULL_CUT" };

            //A set of macros.
            ret = api.SetMacroData(ref one, start_cmd, end_cmd);

            //Serial number initialization.
            api.InitSerial();
            
            //Is there a preview image name specified?
            if (textBox3.Text != "")
            {
                //Create preview image.
                string preview = folder + @"\" + textBox3.Text;
                api.PreviewSopFile(preview);
                //Preview display.
                //If you read the file directly, an exception will occur, so use it via a stream. 
                System.IO.FileStream fs = new System.IO.FileStream(preview, System.IO.FileMode.Open, System.IO.FileAccess.Read);
                pictureBox1.Image = Image.FromStream(fs);
                fs.Close();
            }

            //Is the printer name specified?
            if (textBox6.Text != "")
            {
                //Printing.
                int copies = Int32.Parse(comboBox1.Text);
                api.PrintSopFile(textBox6.Text, copies);
            }

            //Is there a save file name specified?
            if (textBox2.Text != "")
            {
                //File save.
                string save = folder + @"\" + textBox2.Text;
                api.SaveSopFile(save);
            }

            //Get the object list.
            ret = api.GetObjectList(ref obj_list, ref obj_count);
            //Object list acquisition failure?
            if (ret == false)
            {
                MessageBox.Show("Failed to get the object list.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            //Paste the obtained object list in the list box.
            for (int i = 0; i < obj_count; i++)
            {
                listBox1.Items.Add(obj_list[i]);
            }
        }

        //See base folder name.
        private void button2_Click(object sender, EventArgs e)
        {
            folderBrowserDialog1.Description = "Please specify the base folder.";
            folderBrowserDialog1.RootFolder = Environment.SpecialFolder.Desktop;
            folderBrowserDialog1.SelectedPath = @"C:\";
            folderBrowserDialog1.ShowNewFolderButton = true;

            //Display the dialog.
            if (folderBrowserDialog1.ShowDialog(this) == DialogResult.OK)
            {
                textBox1.Text = folderBrowserDialog1.SelectedPath;
                folder = folderBrowserDialog1.SelectedPath;
            }
        }

        //Close.
        private void button3_Click(object sender, EventArgs e)
        {
            Close();
        }

        //See printer name.
        private void button4_Click(object sender, EventArgs e)
        {
            //Display the dialog.
            if (printDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox6.Text = printDialog1.PrinterSettings.PrinterName;
                comboBox1.Text = printDialog1.PrinterSettings.Copies.ToString();
            }
        }

        //Initialize.
        private void Form1_Load(object sender, EventArgs e)
        {
            //Make the working folder the desktop.
            textBox1.Text = System.Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory);
            folder = textBox1.Text;
            //Set the number of prints to 1.
             comboBox1.SelectedIndex = 0;
            //Set the object rotation angle to 0 degrees.
            comboBox2.SelectedIndex = 0;
        }

        //See base SOP file.
        private void button5_Click(object sender, EventArgs e)
        {
            openFileDialog1.FileName = "test.sop";
            openFileDialog1.InitialDirectory = textBox1.Text;
            openFileDialog1.Filter = "SOP File(*.sop)|*.sopl|All files(*.*)|*.*";
            openFileDialog1.FilterIndex = 2;
            openFileDialog1.Title = "Please select a base file.";
            openFileDialog1.RestoreDirectory = true;
            openFileDialog1.CheckFileExists = true;
            openFileDialog1.CheckPathExists = true;

            //The file has been selected.
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                //Set the selected file name in the text box.
                textBox7.Text = openFileDialog1.FileName;
            }
        }
    }
}
