﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace LayoutSDK_Sample
{
    public partial class Form1 : Form
    {
        //ワークフォルダ
        string folder = "";

        public Form1()
        {
            InitializeComponent();
        }

        //実行ボタン
        private void button1_Click(object sender, EventArgs e)
        {
            string sdk_ver = "";
            string eng_ver = "";
            LayoutDesigner2_SDK.LibApi api = new LayoutDesigner2_SDK.LibApi();
            int size = 0;
            string[] obj_list = new string[100];
            int obj_count = 0;
            string one = "";
            Object data = new Object();
            Rectangle rect = new Rectangle(20, 30, 200, 150);
            Point st = new Point(320, 0);
            Point ed = new Point(0, 250);
            int width = 0, type = 0, angle = 0, color = 0, pos = 0, src = 0, cell = 0, ecc = 0, symbol = 0, colum = 0;
            bool aspect = false;
            Bitmap bmp = null;
            string text = "";
            string font_name = "";
            int font_point = 0, font_bold = 0, font_underline = 0, font_strikeout = 0, font_italic = 0, font_charset = 0, text_align = 0;
            int printer_font = 0, width_zoom = 0, height_zoom = 0;
            bool text_autosize = false;
            bool ret = false;
            int api_angle = comboBox2.SelectedIndex;

            //フォルダ指定無し
            if (textBox1.Text == "")
            {
                MessageBox.Show("作業フォルダを指定してください。", "エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            //SDK初期化
            ret = api.InitSdk();
            //初期化失敗？
            if(ret == false)
            {
                MessageBox.Show("SDKの初期化に失敗しました。", "エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            //バージョン取得
            //引数は、SDKバージョン、エンジンバージョン（元になったレイアウトデザイナのバージョン）
            ret = api.GetApiVersion(ref sdk_ver, ref eng_ver);
            //取得失敗？
            if(ret == false)
            {
                MessageBox.Show("バージョンの取得に失敗しました。", "エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            //SDKバージョンをテキストボックスにセット
            textBox8.Text = sdk_ver.ToString();
            //エンジンバージョンをテキストボックスにセット
            textBox9.Text = eng_ver.ToString();

            //リストボックスをクリアする
            listBox1.Items.Clear();

            //ベースSOPファイルの指定がある？
            if (textBox7.Text != "")
            {
                //ファイルロード
                //引数は、読み込むファイル名
                ret = api.LoadSopFile(textBox7.Text, ref size);
                //ロード失敗？
                if (ret == false)
                {
                    MessageBox.Show("ベースSOPファイルの読み込みに失敗しました。", "エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }

                //オブジェクトリストの取得
                //引数は、オブジェクト名配列（文字列の配列）
                ret = api.GetObjectList(ref obj_list, ref obj_count);
                //オブジェクトリスト取得失敗？
                if (ret == false)
                {
                    MessageBox.Show("オブジェクトリストの取得に失敗しました。", "エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }               

                //取得したオブジェクトリストをリストボックスに貼る
                for (int i = 0; i < obj_count; i++)
                {
                    listBox1.Items.Add(obj_list[i]);
                }
            }
            //ベースSOPファイルの指定がなければ新規作成とする
            else
            {
                //新規作成（上のロードが無効になる）
                ret = api.NewSopFile(LayoutDesigner2_SDK.DefineData.PRINTER_SK1_31, 72 * 8, 100 * 8, 0, 0);
                //新規作成失敗？
                if (ret == false)
                {
                    MessageBox.Show("SOPファイルの新規作成に失敗しました。", "エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
            }


            //直線の追加
            //引数は、オブジェクト名、開始座標データ、終了座標データ、線の太さ、線種、回転角度

            //太さに使用出来る定数
            //LayoutDesigner2_SDK.LibApi.LINE_WIDTH_1DOT        1ドット
            //LayoutDesigner2_SDK.LibApi.LINE_WIDTH_2DOT        2ドット
            //LayoutDesigner2_SDK.LibApi.LINE_WIDTH_3DOT        3ドット
            //LayoutDesigner2_SDK.LibApi.LINE_WIDTH_4DOT        4ドット
            //LayoutDesigner2_SDK.LibApi.LINE_WIDTH_5DOT        5ドット
            //LayoutDesigner2_SDK.LibApi.LINE_WIDTH_6DOT        6ドット
            //LayoutDesigner2_SDK.LibApi.LINE_WIDTH_7DOT        7ドット
            //LayoutDesigner2_SDK.LibApi.LINE_WIDTH_8DOT        8ドット
            //LayoutDesigner2_SDK.LibApi.LINE_WIDTH_9DOT        9ドット
            //LayoutDesigner2_SDK.LibApi.LINE_WIDTH_10DOT       10ドット

            //線種に使用出来る定数
            //LayoutDesigner2_SDK.LibApi.LINE_TYPE_SOLID        実線
            //LayoutDesigner2_SDK.LibApi.LINE_TYPE_DASH         破線
            //LayoutDesigner2_SDK.LibApi.LINE_TYPE_DOT          点線
            //LayoutDesigner2_SDK.LibApi.LINE_TYPE_1DOT_CHAIN   １点鎖線
            //LayoutDesigner2_SDK.LibApi.LINE_TYPE_2DOT_CHAIN   ２点鎖線

            //回転角度に使用出来る定数
            //LayoutDesigner2_SDK.LibApi.OBJECT_ANGLE0          回転無し
            //LayoutDesigner2_SDK.LibApi.OBJECT_ANGLE90         90度
            //LayoutDesigner2_SDK.LibApi.OBJECT_ANGLE180        180度
            //LayoutDesigner2_SDK.LibApi.OBJECT_ANGLE270        270度

            one = "";
            ret = api.SetLineData(ref one, st, ed, LayoutDesigner2_SDK.LibApi.LINE_WIDTH_10DOT, LayoutDesigner2_SDK.LibApi.LINE_TYPE_2DOT_CHAIN, api_angle);

            //追加が成功したらそのデータを取得する
            if (ret == true)
            {
                st.X = 0;
                st.Y = 0;
                ed.X = 0;
                ed.Y = 0;
                //直線の取得
                api.GetLineData(one, ref st, ref ed, ref width, ref type, ref angle);
            }

            //矩形の追加
            //引数は、オブジェクト名、矩形データ、線の太さ、線種、回転角度

            //太さに使用出来る定数
            //直線を参照の事

            //線種に使用出来る定数
            //直線を参照の事

            //回転角度に使用出来る定数
            //直線を参照の事

            one = "";
            ret = api.SetRectData(ref one, rect, LayoutDesigner2_SDK.LibApi.LINE_WIDTH_8DOT, LayoutDesigner2_SDK.LibApi.LINE_TYPE_DASH, api_angle);

            //追加が成功したらそのデータを取得する
            if (ret == true)
            {
                rect.X = 0;
                rect.Y = 0;
                rect.Width = 0;
                rect.Height = 0;
                width = type = angle = 0;
                //矩形の取得
                api.GetRectData(one, ref rect, ref width, ref type, ref angle);
            }

            //塗り潰しの追加
            //引数は、オブジェクト名、矩形データ、塗り潰し色、回転角度

            //塗り潰しに使用出来る定数
            //LayoutDesigner2_SDK.LibApi.FILL_COLOR_BLACK       黒
            //LayoutDesigner2_SDK.LibApi.FILL_COLOR_WHITE       白
            //LayoutDesigner2_SDK.LibApi.FILL_COLOR_REVERSE     反転

            //回転角度に使用出来る定数
            //直線を参照の事

            one = "";
            rect.X = 80;
            rect.Y = 250;
            ret = api.SetFillData(ref one, rect, LayoutDesigner2_SDK.LibApi.FILL_COLOR_REVERSE, api_angle);

            //追加が成功したらそのデータを取得する
            if (ret == true)
            {
                rect.X = 0;
                rect.Y = 0;
                rect.Width = 0;
                rect.Height = 0;
                color = angle = 0;
                //塗り潰しの取得
                //引数は、オブジェクト名、矩形データ、塗り潰し色、回転角度
                api.GetFillData(one, ref rect, ref color, ref angle);
            }

            //貼り付け画像の指定あり？
            if (textBox4.Text != "")
            {
                //画像の追加
                //引数は、オブジェクト名、矩形データ、画像ファイル名、2値化の変換種類、2値化の閾値、アスペクト比の設定、回転角度

                //2値化の変換種類に使用出来る定数
                //LayoutDesigner2_SDK.LibApi.IMAGE_CONVERT_SIMPLE                   //単純2値化
                //LayoutDesigner2_SDK.LibApi.IMAGE_CONVERT_DITHER                   //ディザ
                //LayoutDesigner2_SDK.LibApi.IMAGE_CONVERT_ERROR_DIFFUSION_METHOD   //誤差拡散

                //2値化の閾値は、０～２５５の範囲

                //アスペクト比の設定に使用出来る定数
                //LayoutDesigner2_SDK.LibApi.ASPECT_RATIO_NON_KEEP      アスペクト比を維持しない
                //LayoutDesigner2_SDK.LibApi.ASPECT_RATIO_KEEP          アスペクト比を維持する

                //回転角度に使用出来る定数
                //直線を参照の事

                one = "";
                rect.X = 8;
                rect.Y = 300;
                rect.Width = 80;
                rect.Height = 80;
                string image = folder + @"\" + textBox4.Text;
                ret = api.SetImageData(ref one, rect, image, LayoutDesigner2_SDK.LibApi.IMAGE_CONVERT_SIMPLE, 120, LayoutDesigner2_SDK.LibApi.ASPECT_RATIO_NON_KEEP, api_angle);

                //追加が成功したらそのデータを取得する
                if (ret == true)
                {
                    rect.X = 0;
                    rect.Y = 0;
                    rect.Width = 0;
                    rect.Height = 0;
                    angle = 0;
                    aspect = true;
                    //画像の取得
                    //引数は、オブジェクト名、矩形データ、ビットマップデータ、アスペクトの設定、回転角度
                    api.GetImageData(one, ref rect, ref bmp, ref aspect, ref angle);

                    //取得画像名の指定あり？
                    if (textBox5.Text != "")
                    {
                        //デバッグの為、画像ファイルを保存
                        string image2 = folder + @"\" + textBox5.Text;
                        bmp.Save(image2);
                    }
                }
            }

            //テキストデータのシリアル番号初期化
            //            api.SetSerielNumber(0, 0, 0, 0, "", 0, 0, 0, 0);
            //api.SetSerielNumber(true, 1, 0, 1, 1, "", 1, 5, 1, 1);

            //１次元バーコードのセット
            //引数は、オブジェクト名、矩形データ、テキストデータ、バーコードソース、バーコードタイプ、HRI文字の位置、バーの太さ、回転角度

            //バーコードソースに使用出来る定数
            //LayoutDesigner2_SDK.LibApi.BARCODE_SOURCE_TEXT    バーコードデータは、テキストを使用する
            //LayoutDesigner2_SDK.LibApi.BARCODE_SOURCE_SERIAL  バーコードデータは、シリアル番号を使用する

            //（1次元）バーコードタイプに使用出来る定数
            //LayoutDesigner2_SDK.LibApi.BARCODE1D_TYPE_UPCA        UPC-A
            //LayoutDesigner2_SDK.LibApi.BARCODE1D_TYPE_UPCE        UPC-E
            //LayoutDesigner2_SDK.LibApi.BARCODE1D_TYPE_JAN13       JAN13
            //LayoutDesigner2_SDK.LibApi.BARCODE1D_TYPE_JAN8        JAN8
            //LayoutDesigner2_SDK.LibApi.BARCODE1D_TYPE_CODE39      CODE39
            //LayoutDesigner2_SDK.LibApi.BARCODE1D_TYPE_ITF         ITF
            //LayoutDesigner2_SDK.LibApi.BARCODE1D_TYPE_CODABAR     CODABAR(NW-7)
            //LayoutDesigner2_SDK.LibApi.BARCODE1D_TYPE_CODE128     CODE128
            //LayoutDesigner2_SDK.LibApi.BARCODE1D_TYPE_CODE93      CODE93

            //HRI文字の位置に使用出来る定数
            //LayoutDesigner2_SDK.LibApi.HRI_LOCATE_NONE        HRI文字を使用しない
            //LayoutDesigner2_SDK.LibApi.HRI_LOCATE_UPPER       HRI文字をバーコード上側に配置
            //LayoutDesigner2_SDK.LibApi.HRI_LOCATE_BOTTOM      HRI文字をバーコード下側に配置
            //LayoutDesigner2_SDK.LibApi.HRI_LOCATE_BOTH        HRI文字をバーコードの上下に配置

            //バーの太さに使用出来る定数
            ///LayoutDesigner2_SDK.LibApi.BARCODE_WIDTH1        バーコード幅１ドット
            ///LayoutDesigner2_SDK.LibApi.BARCODE_WIDTH2        バーコード幅２ドット
            ///LayoutDesigner2_SDK.LibApi.BARCODE_WIDTH3        バーコード幅３ドット
            ///LayoutDesigner2_SDK.LibApi.BARCODE_WIDTH4        バーコード幅４ドット

            //回転角度に使用出来る定数
            //直線を参照の事

            one = "";
            rect.X = 0;
            rect.Y = 300;
            rect.Width = 200;
            rect.Height = 50;
            ret = api.SetBarcode1dData(ref one, rect, @"12345678901", LayoutDesigner2_SDK.LibApi.BARCODE_SOURCE_TEXT, LayoutDesigner2_SDK.LibApi.BARCODE1D_TYPE_UPCA, LayoutDesigner2_SDK.LibApi.HRI_LOCATE_BOTH, 
                                LayoutDesigner2_SDK.LibApi.BARCODE_WIDTH1, api_angle);

            //追加が成功したらそのデータを取得する
            if (ret == true)
            {
                rect.X = 0;
                rect.Y = 0;
                rect.Width = 0;
                rect.Height = 0;
                type = 0;
                angle = 0;
                pos = 0;
                src = 0;
                text = "";
                //１次元バーコードの取得
                api.GetBarcode1dData(one, ref rect, ref text, ref src, ref type, ref pos, ref width, ref angle);
            }

            //２次元バーコードのセット
            //引数は、オブジェクト名、矩形データ、テキストデータ、バーコードソース、バーコードタイプ、セルサイズ、ECCレベル、シンボルサイズ、列数、回転角度

            //バーコードソースに使用出来る定数
            //1次元バーコードを参照の事

            //（2次元）バーコードタイプに使用出来る定数
            //LayoutDesigner2_SDK.LibApi.BARCODE2D_TYPE_QRCODE              QR CODE
            //LayoutDesigner2_SDK.LibApi.BARCODE2D_TYPE_MICRO_QRCODE        マイクロQR CODE
            //LayoutDesigner2_SDK.LibApi.BARCODE2D_TYPE_PDF417              PDF417
            //LayoutDesigner2_SDK.LibApi.BARCODE2D_TYPE_MICRO_PDF417        マイクロPDF417
            //LayoutDesigner2_SDK.LibApi.BARCODE2D_TYPE_DATA_MATRIX         DATA MATRIX
            //LayoutDesigner2_SDK.LibApi.BARCODE2D_TYPE_MAXI_CODE           MAXI CODE

            //セルサイズに使用出来る定数
            //LayoutDesigner2_SDK.LibApi.QRCODE_CELL_SIZE1      セルサイズ1
            //LayoutDesigner2_SDK.LibApi.QRCODE_CELL_SIZE2      セルサイズ2
            //LayoutDesigner2_SDK.LibApi.QRCODE_CELL_SIZE3      セルサイズ3
            //LayoutDesigner2_SDK.LibApi.QRCODE_CELL_SIZE4      セルサイズ4
            //LayoutDesigner2_SDK.LibApi.QRCODE_CELL_SIZE5      セルサイズ5
            //LayoutDesigner2_SDK.LibApi.QRCODE_CELL_SIZE6      セルサイズ6
            //LayoutDesigner2_SDK.LibApi.QRCODE_CELL_SIZE7      セルサイズ7
            //LayoutDesigner2_SDK.LibApi.QRCODE_CELL_SIZE8      セルサイズ8

            //ECCレベルに使用出来る定数
            //QR CODE
            //LayoutDesigner2_SDK.LibApi.QRCODE_ECC_L       ECCレベル7%
            //LayoutDesigner2_SDK.LibApi.QRCODE_ECC_M       ECCレベル15%
            //LayoutDesigner2_SDK.LibApi.QRCODE_ECC_Q       ECCレベル25%
            //LayoutDesigner2_SDK.LibApi.QRCODE_ECC_H       ECCレベル30%
            //PDF417
            //LayoutDesigner2_SDK.LibApi.PDF417_ECC_0       ECCレベル0
            //LayoutDesigner2_SDK.LibApi.PDF417_ECC_1       ECCレベル1
            //LayoutDesigner2_SDK.LibApi.PDF417_ECC_2       ECCレベル2
            //LayoutDesigner2_SDK.LibApi.PDF417_ECC_3       ECCレベル3
            //LayoutDesigner2_SDK.LibApi.PDF417_ECC_4       ECCレベル4
            //LayoutDesigner2_SDK.LibApi.PDF417_ECC_5       ECCレベル5
            //LayoutDesigner2_SDK.LibApi.PDF417_ECC_6       ECCレベル6
            //LayoutDesigner2_SDK.LibApi.PDF417_ECC_7       ECCレベル7
            //LayoutDesigner2_SDK.LibApi.PDF417_ECC_8       ECCレベル8

            //シンボルサイズは、１～４０の範囲（QR CODEの場合）、もしくは１～１４４の範囲（DATA MATRIXの場合）
            //シンボルサイズに使用出来る定数
            //LayoutDesigner2_SDK.LibApi.QRCODE_SYMBOL_MIN_SIZE             シンボル最小サイズ（QR CODE）
            //LayoutDesigner2_SDK.LibApi.QRCODE_SYMBOL_MAX_SIZE             シンボル最大サイズ（QR CODE）
            //LayoutDesigner2_SDK.LibApi.DATAMATRIX_SYMBOL_MIN_SIZE         シンボル最小サイズ（DATA MATRIX）
            //LayoutDesigner2_SDK.LibApi.DATAMATRIX_SYMBOL_MAX_SIZE         シンボル最大サイズ（DATA MATRIX）

            //列数に使用出来る定数
            //LayoutDesigner2_SDK.LibApi.MICRO_PDF417_COLUMNS_SIZE1         列数1
            //LayoutDesigner2_SDK.LibApi.MICRO_PDF417_COLUMNS_SIZE2         列数2
            //LayoutDesigner2_SDK.LibApi.MICRO_PDF417_COLUMNS_SIZE3         列数3
            //LayoutDesigner2_SDK.LibApi.MICRO_PDF417_COLUMNS_SIZE4         列数4

            //回転角度に使用出来る定数
            //直線を参照の事

            one = "";
            rect.X = 0;
            rect.Y = 0;
            rect.Width = 200;
            rect.Height = 200;
            ret = api.SetBarcode2dData(ref one, rect, "12345678", LayoutDesigner2_SDK.LibApi.BARCODE_SOURCE_TEXT, LayoutDesigner2_SDK.LibApi.BARCODE2D_TYPE_QRCODE,  LayoutDesigner2_SDK.LibApi.QRCODE_CELL_SIZE1, 
                                LayoutDesigner2_SDK.LibApi.QRCODE_ECC_Q, 6, LayoutDesigner2_SDK.LibApi.MICRO_PDF417_COLUMNS_SIZE1 , api_angle);

            //追加が成功したらそのデータを取得する
            if (ret == true)
            {
                rect.X = 0;
                rect.Y = 0;
                rect.Width = 0;
                rect.Height = 0;
                type = 0;
                angle = 0;
                pos = 0;
                src = 0;
                text = "";
                //２次元バーコードの取得
                api.GetBarcode2dData(one, ref rect, ref text, ref src, ref type, ref cell, ref ecc, ref symbol, ref colum, ref angle);
            }


            //シリアル番号のセット
            //引数は、オブジェクトタイプ、シリアル番号種類、シリアル番号増減、同一シリアル番号の印刷枚数、シリアル番号増減単位、シリアル番号書式、シリアル番号初期値、シリアル番号最大値、現シリアル番号、同一シリアル番号の現印刷枚数

            //オブジェクトタイプに使用出来る定数
            //LayoutDesigner2_SDK.LibApi.OBJECT_TYPE_TEXT               テキスト
            //LayoutDesigner2_SDK.LibApi.OBJECT_TYPE_BARCODE            バーコード

            //シリアル番号種類に使用出来る定数
            //LayoutDesigner2_SDK.LibApi.SERIAL_TYPE_DECIMAL            １０進数

            //シリアル番号増減に使用出来る定数
            //LayoutDesigner2_SDK.LibApi.SERIAL_NUMBER_INC              連番増加
            //LayoutDesigner2_SDK.LibApi.SERIAL_NUMBER_DEC              連番減少

            //同一シリアル番号の印刷枚数に使用出来る定数
            //API側で用意している定数は無し

            //シリアル番号増減単位に使用出来る定数
            //API側で用意している定数は無し

            //シリアル番号書式に使用出来る定数
            //API側で用意している定数は無し
            //シリアル書式は、C#やVB.NETの書式形式を指定する

            //シリアル番号初期値に使用出来る定数
            //API側で用意している定数は無し

            //シリアル番号最大値に使用出来る定数
            //API側で用意している定数は無し

            //現シリアル番号に使用出来る定数
            //API側で用意している定数は無し

            //同一シリアル番号の現印刷枚数に使用出来る定数
            //API側で用意している定数は無し


            //シリアル番号の設定
            api.SetSerielNumber(LayoutDesigner2_SDK.LibApi.OBJECT_TYPE_TEXT, LayoutDesigner2_SDK.LibApi.SERIAL_TYPE_DECIMAL, LayoutDesigner2_SDK.LibApi.SERIAL_NUMBER_INC, 1, 1, "#", 1, 5, 1, 1);
            one = "";
            rect.X = 200;
            rect.Y = 200;
            rect.Width = 200;
            rect.Height = 200;
            ret = api.SetTextData(ref one, rect, "", 2, "MS ゴシック", 20, 1, 1, 1, 1, 1, 1, true, api_angle);


            //日付／時刻のセット
            //引数は、日付／時刻の選択、日付／時刻の書式番号、オフセット情報１、オフセット情報２

            //日付／時刻の選択に使用出来る定数
            //LayoutDesigner2_SDK.LibApi.SELECT_TYPE_DATE       日付の選択
            //LayoutDesigner2_SDK.LibApi.SELECT_TYPE_TIME       時刻の選択

            //日付の書式番号に使用出来る定数
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE01             2021/04/13(Year/Month/Day)
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE02             21/04/13(Year/Month/Day)
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE03             2021-04-13(Year-Month-Day)
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE04             21-04-13(Year-Month-Day)
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE05             2021,04,13(Year,Month,Day)
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE06             21,04,13(Year,Month,Day)
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE07             2021.04.13(Year.Month.Day)
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE08             21.04.13(Year,Month.Day)
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE09             2021年04月13日
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE10             21年04月13日
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE11             2021年04月13日 火曜日
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE12             21年04月13日 火曜日
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE13             令和03年04月13日
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE14             R03年04月13日
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE15             R03/04/13(Year/Month/Day)
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE16             R03-04-13(Year-Month-Day)
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE17             R03,04,13(Year,Month,Day)
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE18             R03.04.13(Year.Month.Day)
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE19             210413(YearMonthDay)
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE20             20210413(YearMonthDay)
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE21             火(DayOfWeek)
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE22             21(Year)
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE23             2021(Year)
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE24             04(Month)
            //LayoutDesigner2_SDK.LibApi.DATE_FORMAT_TYPE25             13(Day)

            //時刻の書式番号に使用出来る定数
            //LayoutDesigner2_SDK.LibApi.TIME_FORMAT_TYPE01             02:22 PM(12 Hour Format)
            //LayoutDesigner2_SDK.LibApi.TIME_FORMAT_TYPE02             02:22(12 Hour Format)
            //LayoutDesigner2_SDK.LibApi.TIME_FORMAT_TYPE03             02:22:19(12 Hour Format)
            //LayoutDesigner2_SDK.LibApi.TIME_FORMAT_TYPE04             02:22:19(12 Hour Format:2Digits)
            //LayoutDesigner2_SDK.LibApi.TIME_FORMAT_TYPE05             02:22:19 PM(12 Hour Format)
            //LayoutDesigner2_SDK.LibApi.TIME_FORMAT_TYPE06             14:22 PM(24 Hour Format)
            //LayoutDesigner2_SDK.LibApi.TIME_FORMAT_TYPE07             14:22(24 Hour Format)
            //LayoutDesigner2_SDK.LibApi.TIME_FORMAT_TYPE08             14:22:19(24 Hour Format)
            //LayoutDesigner2_SDK.LibApi.TIME_FORMAT_TYPE09             14:22:19(24 Hour Format:2Digits)
            //LayoutDesigner2_SDK.LibApi.TIME_FORMAT_TYPE10             02時22分(12 Hour Format)
            //LayoutDesigner2_SDK.LibApi.TIME_FORMAT_TYPE11             14時22分(24 Hour Format)
            //LayoutDesigner2_SDK.LibApi.TIME_FORMAT_TYPE12             02時22分19秒(12 Hour Format)
            //LayoutDesigner2_SDK.LibApi.TIME_FORMAT_TYPE13             14時22分19秒(24 Hour Format)
            //LayoutDesigner2_SDK.LibApi.TIME_FORMAT_TYPE14             午後 02時22分(12 Hour Format)
            //LayoutDesigner2_SDK.LibApi.TIME_FORMAT_TYPE15             午後 14時22分(24 Hour Format)
            //LayoutDesigner2_SDK.LibApi.TIME_FORMAT_TYPE16             PM
            //LayoutDesigner2_SDK.LibApi.TIME_FORMAT_TYPE17             02時00分(12 Hour Format)
            //LayoutDesigner2_SDK.LibApi.TIME_FORMAT_TYPE18             14時00分(24 Hour Format)
            //LayoutDesigner2_SDK.LibApi.TIME_FORMAT_TYPE19             02:00(12 Hour Format)
            //LayoutDesigner2_SDK.LibApi.TIME_FORMAT_TYPE20             14:00(24 Hour Format)


            //日付／時刻の選択が日付だった場合、オフセット情報１がオフセット種類になり、オフセット情報２がオフセットになる
            //日付／時刻の選択が時刻だった場合、オフセット情報１が時のオフセットになり、オフセット情報２が分のオフセットになる

            //オフセット情報1に使用出来る定数
            //LayoutDesigner2_SDK.LibApi.OFFSET_TYPE_DAY                日のオフセット種類
            //LayoutDesigner2_SDK.LibApi.OFFSET_TYPE_MONTH              月のオフセット種類
            //LayoutDesigner2_SDK.LibApi.OFFSET_TYPE_YEAR               年のオフセット種類

            //オフセット情報2に使用出来る定数
            ////日のオフセット範囲
            //LayoutDesigner2_SDK.LibApi.OFFSET_DAY_MIN                 日のオフセット最小値
            //LayoutDesigner2_SDK.LibApi.OFFSET_DAY_MAX                 日のオフセット最大値

            //月のオフセット範囲
            //LayoutDesigner2_SDK.LibApi.OFFSET_MONTH_MIN               月のオフセット最小値
            //LayoutDesigner2_SDK.LibApi.OFFSET_MONTH_MAX               月のオフセット最大値

            //年のオフセット範囲
            //LayoutDesigner2_SDK.LibApi.OFFSET_YEAR_MIN                年のオフセット最小値
            //LayoutDesigner2_SDK.LibApi.OFFSET_YEAR_MAX                年のオフセット最大値



            //日付／時刻の設定
            api.SetDataTime(LayoutDesigner2_SDK.LibApi.SELECT_TYPE_TIME, LayoutDesigner2_SDK.LibApi.TIME_FORMAT_TYPE01, 0, 0);
            one = "";
            rect.X = 30;
            rect.Y = 150;
            rect.Width = 200;
            rect.Height = 300;

            //テキストデータのセット
            //引数は、オブジェクト名、矩形データ、テキストデータ、テキストソース、フォント名、フォントサイズ、強調修飾、イタリック修飾、アンダーライン修飾、取り消し線修飾、キャラクタセット、テキストの配置、自動サイズ調整、回転角度

            //テキストソースに使用出来る定数
            //LayoutDesigner2_SDK.LibApi.TEXT_SOURCE_TEXT       テキストデータは、テキストを使用する
            //LayoutDesigner2_SDK.LibApi.TEXT_SOURCE_DATE       テキストデータは、日付／時刻を使用する
            //LayoutDesigner2_SDK.LibApi.TEXT_SOURCE_SERIAL     テキストデータは、シリアル番号を使用する

            //強調修飾に使用出来る定数
            //LayoutDesigner2_SDK.LibApi.TEXT_BOLD_ENABLE               強調修飾有効
            //LayoutDesigner2_SDK.LibApi.TEXT_BOLD_DISABLE              強調修飾無効

            //イタリック修飾に使用出来る定数
            //LayoutDesigner2_SDK.LibApi.TEXT_ITALIC_ENABLE             イタリック修飾有効
            //LayoutDesigner2_SDK.LibApi.TEXT_ITALIC_DISABLE            イタリック修飾無効

            //アンダーライン修飾に使用出来る定数
            //LayoutDesigner2_SDK.LibApi.TEXT_UNDERLINE_ENABLE          アンダーライン修飾有効
            //LayoutDesigner2_SDK.LibApi.TEXT_UNDERLINE_DISABLE         アンダーライン修飾無効

            //取り消し線修飾に使用出来る定数
            //LayoutDesigner2_SDK.LibApi.TEXT_STRIKEOUT_ENABLE          取り消し線修飾有効
            //LayoutDesigner2_SDK.LibApi.TEXT_STRIKEOUT_DISABLE         取り消し線修飾無効

            //キャラクタセットに使用出来る定数
            //LayoutDesigner2_SDK.LibApi.CHARACTER_SET_JAPAN            キャラクタセット日本語
            //LayoutDesigner2_SDK.LibApi.CHARACTER_SET_EURO             キャラクタセット欧文

            //テキストの配置に使用出来る定数
            //LayoutDesigner2_SDK.LibApi.TEXT_ALIGN_LEFT                左詰
            //LayoutDesigner2_SDK.LibApi.TEXT_ALIGN_CENTER              センタリング
            //LayoutDesigner2_SDK.LibApi.TEXT_ALIGN_RIGHT               右詰

            //自動サイズ調整に使用出来る定数
            //LayoutDesigner2_SDK.LibApi.TEXT_AUTO_SIZE_ENABLE          自動サイズ調整有効
            //LayoutDesigner2_SDK.LibApi.TEXT_AUTO_SIZE_DISABLE         自動サイズ調整無効

            //回転角度に使用出来る定数
            //直線を参照の事

            ret = api.SetTextData(ref one, rect, "", LayoutDesigner2_SDK.LibApi.TEXT_SOURCE_DATE, "MS ゴシック", 20, LayoutDesigner2_SDK.LibApi.TEXT_BOLD_ENABLE, LayoutDesigner2_SDK.LibApi.TEXT_ITALIC_ENABLE, 
                                LayoutDesigner2_SDK.LibApi.TEXT_UNDERLINE_ENABLE, LayoutDesigner2_SDK.LibApi.TEXT_STRIKEOUT_ENABLE , LayoutDesigner2_SDK.LibApi.CHARACTER_SET_JAPAN, LayoutDesigner2_SDK.LibApi.TEXT_ALIGN_CENTER,
                                LayoutDesigner2_SDK.LibApi.TEXT_AUTO_SIZE_ENABLE, api_angle);

            //追加が成功したらそのデータを取得する
            if (ret == true)
            {
                rect.X = 0;
                rect.Y = 0;
                rect.Width = 0;
                rect.Height = 0;
                type = 0;
                angle = 0;
                pos = 0;
                src = 0;
                text = "";
                font_name = "";
                font_point = 0;
                font_bold = 0;
                font_italic = 0;
                font_underline = 0;
                font_strikeout = 0;
                font_charset = 0;
                text_align = 0;
                text_autosize = false;
                //テキストの取得
                api.GetTextData(one, ref rect, ref text, ref src, ref font_name, ref font_point, ref font_bold, ref font_italic,
                                ref font_underline, ref font_strikeout, ref font_charset, ref text_align, ref text_autosize, ref angle);
            }


            //セットするテキストデータ
            one = "";
            rect.X = 100;
            rect.Y = 150;
            rect.Width = 200;
            rect.Height = 200;

            //プリンタテキストデータのセット
            //引数は、オブジェクト名、矩形データ、テキストデータ、テキストソース、プリンタテキストタイプ、強調修飾、イタリック修飾、アンダーライン修飾、横倍角サイズ、縦倍角サイズ、回転角度

            //テキストソースに使用出来る定数
            //テキストを参照の事

            //プリンタテキストフォントタイプに使用出来る定数
            //LayoutDesigner2_SDK.LibApi.PTEXT_FONTA         フォントＡ（24ドット）
            //LayoutDesigner2_SDK.LibApi.PTEXT_FONTB         フォントＢ（16ドット）

            //強調修飾に使用出来る定数
            //テキストを参照の事

            //イタリック修飾に使用出来る定数
            //テキストを参照の事

            //アンダーライン修飾に使用出来る定数
            //テキストを参照の事

            //プリンタテキスト倍角サイズ
            //LayoutDesigner2_SDK.LibApi.PTEXT_ZOOM_SIZE1       1倍
            //LayoutDesigner2_SDK.LibApi.PTEXT_ZOOM_SIZE2       2倍
            //LayoutDesigner2_SDK.LibApi.PTEXT_ZOOM_SIZE3       3倍
            //LayoutDesigner2_SDK.LibApi.PTEXT_ZOOM_SIZE4       4倍
            //LayoutDesigner2_SDK.LibApi.PTEXT_ZOOM_SIZE5       5倍
            //LayoutDesigner2_SDK.LibApi.PTEXT_ZOOM_SIZE6       6倍
            //LayoutDesigner2_SDK.LibApi.PTEXT_ZOOM_SIZE7       7倍
            //LayoutDesigner2_SDK.LibApi.PTEXT_ZOOM_SIZE8       8倍

            //回転角度に使用出来る定数
            //直線を参照の事

            ret = api.SetPTextData(ref one, rect, "一味違うことを、一足早くやる。", LayoutDesigner2_SDK.LibApi.TEXT_SOURCE_TEXT, LayoutDesigner2_SDK.LibApi.PTEXT_FONTB, LayoutDesigner2_SDK.LibApi.TEXT_BOLD_ENABLE, 
                                LayoutDesigner2_SDK.LibApi.TEXT_ITALIC_ENABLE, LayoutDesigner2_SDK.LibApi.TEXT_UNDERLINE_ENABLE, LayoutDesigner2_SDK.LibApi.PTEXT_ZOOM_SIZE2, LayoutDesigner2_SDK.LibApi.PTEXT_ZOOM_SIZE2,
                                api_angle);

            //追加が成功したらそのデータを取得する
            if (ret == true)
            {
                rect.X = 0;
                rect.Y = 0;
                rect.Width = 0;
                rect.Height = 0;
                type = 0;
                angle = 0;
                pos = 0;
                src = 0;
                text = "";
                font_name = "";
                font_point = 0;
                font_bold = 0;
                font_italic = 0;
                font_underline = 0;
                width_zoom = 0;
                height_zoom = 0;

                //プリンタテキストの取得
                api.GetPTextData(one, ref rect, ref text, ref src, ref printer_font, ref font_bold, ref font_italic, ref font_underline, ref width_zoom, ref height_zoom, ref angle);
            }

            //セットするマクロのデータ
            string[] start_cmd = { };
            string[] end_cmd = { "FEED,128", "FULL_CUT" };

            //マクロのセット
            ret = api.SetMacroData(ref one, start_cmd, end_cmd);

            //追加が成功したらそのデータを取得する
            if (ret == true)
            {
                string[] start_cmd_get = { };
                string[] end_cmd_get = { };

                //マクロの取得
                ret = api.GetMacroData(one, ref start_cmd_get, ref end_cmd_get);

            }

            //オブジェクトの削除
            //引数は、削除するオブジェクト名
            api.DelObjectData(@"RECT000001");
            api.DelObjectData(@"BAR2000000");
            api.DelObjectData(@"TEXT000000");

            //シリアル番号の初期化
            api.InitSerial();

            //保存ファイル名の指定あり？
            if (textBox2.Text != "")
            {
                //ファイルセーブ
                //引数は、保存ファイル名
                string save = folder + @"\" + textBox2.Text;
                api.SaveSopFile(save);
            }

            //プレビュー画像名の指定あり？
            if (textBox3.Text != "")
            {
                //プレビューイメージ作成
                //引数は、画像ファイル名（画像フォーマットは、PNG）
                string preview = folder + @"\" + textBox3.Text;
                api.PreviewSopFile(preview);
                //プレビュー表示
                //直接ファイルを読み込むと例外が起きるのでストリーム経由とする
                System.IO.FileStream fs = new System.IO.FileStream(preview, System.IO.FileMode.Open, System.IO.FileAccess.Read);
                pictureBox1.Image = Image.FromStream(fs);
                fs.Close();
            }

            //印刷プリンタ名の指定あり？
            if (textBox6.Text != "")
            {
                //印刷
                int copies = Int32.Parse(comboBox1.Text);
                //引数は、プリンタ名と印字枚数
                api.PrintSopFile(textBox6.Text, copies);
            }
        }

        //ベースフォルダ名の参照
        private void button2_Click(object sender, EventArgs e)
        {
            //上部に表示する説明テキストを指定する
            folderBrowserDialog1.Description = "ベースフォルダを指定してください。";
            //ルートフォルダを指定する
            //デフォルトでDesktop
            folderBrowserDialog1.RootFolder = Environment.SpecialFolder.Desktop;
            //最初に選択するフォルダを指定する
            //RootFolder以下にあるフォルダである必要がある
            folderBrowserDialog1.SelectedPath = @"C:\";
            //ユーザーが新しいフォルダを作成できるようにする
            //デフォルトでTrue
            folderBrowserDialog1.ShowNewFolderButton = true;

            //ダイアログを表示する
            if (folderBrowserDialog1.ShowDialog(this) == DialogResult.OK)
            {
                textBox1.Text = folderBrowserDialog1.SelectedPath;
                folder = folderBrowserDialog1.SelectedPath;
            }
        }

        //終了ボタン
        private void button3_Click(object sender, EventArgs e)
        {
            Close();
        }

        //プリンタ名の参照
        private void button4_Click(object sender, EventArgs e)
        {
            //印刷の選択ダイアログを表示する
            if (printDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox6.Text = printDialog1.PrinterSettings.PrinterName;
                comboBox1.Text = printDialog1.PrinterSettings.Copies.ToString();
            }
        }

        //実行前初期化
        private void Form1_Load(object sender, EventArgs e)
        {
            //作業フォルダをデスクトップにする
            textBox1.Text = System.Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory);
            folder = textBox1.Text;
            //印刷枚数を１とする
            comboBox1.SelectedIndex = 0;
            //オブジェクト回転角度を0度にする
            comboBox2.SelectedIndex = 0;
        }

        //ベースSOPファイルの参照
        private void button5_Click(object sender, EventArgs e)
        {
            //はじめに「ファイル名」で表示される文字列を指定する
            openFileDialog1.FileName = "test.sop";
            //はじめに表示されるフォルダを指定する
            openFileDialog1.InitialDirectory = textBox1.Text;
            //[ファイルの種類]に表示される選択肢を指定する
            //指定しないとすべてのファイルが表示される
            openFileDialog1.Filter = "SOPファイル(*.sop)|*.sopl|すべてのファイル(*.*)|*.*";
            //[ファイルの種類]ではじめに選択されるものを指定する
            //2番目の「すべてのファイル」が選択されているようにする
            openFileDialog1.FilterIndex = 2;
            //タイトルを設定する
            openFileDialog1.Title = "ベースファイルを選択してください。";
            //ダイアログボックスを閉じる前に現在のディレクトリを復元するようにする
            openFileDialog1.RestoreDirectory = true;
            //存在しないファイルの名前が指定されたとき警告を表示する
            //デフォルトでTrueなので指定する必要はない
            openFileDialog1.CheckFileExists = true;
            //存在しないパスが指定されたとき警告を表示する
            //デフォルトでTrueなので指定する必要はない
            openFileDialog1.CheckPathExists = true;

            //ファイルが選択された
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                //選択されたファイル名をテキストボックスに
                textBox7.Text = openFileDialog1.FileName;
            }
        }
    }
}
